/*****************************************************************************
*
*	File Name:    Serial26.H                                       
*                                                                  
*	Content:      Header file for the RS232 Serial Port driver for UART0 of 
*                 the M16C/26 MCU.                
*                                                                  
*	Copyright (c) 2002 Mitsubishi Electric & Electronics USA, Inc.                       
*	All rights reserved
*
*	Mitsubishi Electric & Electronics USA does not guarantee the performance or 
*	use of this source-code.  The intended use of provided source-code is the 
*	sole responsible of the user.  The files have been successfully compiled 
*	using Mitsubishi's NC30 compiler.  Before using this software review the 
*   source and make any necessary changes to support your hardware and application.
*                                                               
*=============================================================================
*	$Log:$
*===========================================================================*/
#ifndef MAIN_CLOCK
#define MAIN_CLOCK	   (unsigned long)20e6	// 20MHz Operating Frequency
#endif
#define BAUDRATE  9600  // UART0 baud rate
#define DIV_RATE  0		// Valid entries are 0, 1, 2... Where:
						// 0 = clock divide rate of 1,
						// 1 = clock divide rate of 8,
						// 2 = clock divide rate of 32
#define FC_VALUE  1000  // define FC value if  DIV_RATE == 3  

#define  XMIT_BUFFER_SIZE 		10	
#define  RECEIVE_BUFFER_SIZE 	10

#ifndef SERIAL_C
extern int char_recv(void);
extern void xmit_schar(char c);		// Transmit single char form serial port. 
extern char recv_schar(void);		// Received single char to serial port.
extern void Rcev_intr(void);
extern void Xmit_intr(void);
#endif	

#if DIV_RATE == 0
#define BRG_REG_VALUE      (unsigned char)(( MAIN_CLOCK / ( BAUDRATE * 16 * 1) ) -1)
#elif DIV_RATE == 1
#define BRG_REG_VALUE      (unsigned char)(( MAIN_CLOCK / ( BAUDRATE * 16 * 8) ) -1)
#elif DIV_RATE == 2
#define BRG_REG_VALUE      (unsigned char)(( MAIN_CLOCK / ( BAUDRATE * 16 * 32) ) -1)
#endif
